# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ainstein_radar_msgs/RadarAlarmArray.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ainstein_radar_msgs.msg
import std_msgs.msg

class RadarAlarmArray(genpy.Message):
  _md5sum = "a2ed2b28cdaf4bd421182c41d9016e57"
  _type = "ainstein_radar_msgs/RadarAlarmArray"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message describes an array of alarms with a timestamp.

std_msgs/Header header

RadarAlarm[] alarms

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: ainstein_radar_msgs/RadarAlarm
# This message describes alarms (eg BSD) from a RADAR sensor.

bool LCA_alarm    # Lane Change Assist alarm
bool CVW_alarm    # Collision (Vehicle?) Warning alarm
bool BSD_alarm    # Blind Spot Detection alarm
"""
  __slots__ = ['header','alarms']
  _slot_types = ['std_msgs/Header','ainstein_radar_msgs/RadarAlarm[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,alarms

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarAlarmArray, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.alarms is None:
        self.alarms = []
    else:
      self.header = std_msgs.msg.Header()
      self.alarms = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.alarms)
      buff.write(_struct_I.pack(length))
      for val1 in self.alarms:
        _x = val1
        buff.write(_get_struct_3B().pack(_x.LCA_alarm, _x.CVW_alarm, _x.BSD_alarm))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.alarms is None:
        self.alarms = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.alarms = []
      for i in range(0, length):
        val1 = ainstein_radar_msgs.msg.RadarAlarm()
        _x = val1
        start = end
        end += 3
        (_x.LCA_alarm, _x.CVW_alarm, _x.BSD_alarm,) = _get_struct_3B().unpack(str[start:end])
        val1.LCA_alarm = bool(val1.LCA_alarm)
        val1.CVW_alarm = bool(val1.CVW_alarm)
        val1.BSD_alarm = bool(val1.BSD_alarm)
        self.alarms.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.alarms)
      buff.write(_struct_I.pack(length))
      for val1 in self.alarms:
        _x = val1
        buff.write(_get_struct_3B().pack(_x.LCA_alarm, _x.CVW_alarm, _x.BSD_alarm))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.alarms is None:
        self.alarms = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.alarms = []
      for i in range(0, length):
        val1 = ainstein_radar_msgs.msg.RadarAlarm()
        _x = val1
        start = end
        end += 3
        (_x.LCA_alarm, _x.CVW_alarm, _x.BSD_alarm,) = _get_struct_3B().unpack(str[start:end])
        val1.LCA_alarm = bool(val1.LCA_alarm)
        val1.CVW_alarm = bool(val1.CVW_alarm)
        val1.BSD_alarm = bool(val1.BSD_alarm)
        self.alarms.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
