# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ainstein_radar_msgs/RadarTarget.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RadarTarget(genpy.Message):
  _md5sum = "942d59f5ed2080c1747d5b79ce6dc1c0"
  _type = "ainstein_radar_msgs/RadarTarget"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message describes a target (detection) from a RADAR sensor.

uint16 target_id    # ID of the target, as set by the sensor
float64 snr         # Signal-to-noise ratio
float64 range       # Distance from sensor to target along sensor x-axis
float64 speed       # Speed (range rate of change) of target along sensor x-axis
float64 azimuth     # Angle of target relative to sensor within x-y plane
float64 elevation   # Angle of target relative to sensor within y-z plane
"""
  __slots__ = ['target_id','snr','range','speed','azimuth','elevation']
  _slot_types = ['uint16','float64','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       target_id,snr,range,speed,azimuth,elevation

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarTarget, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.target_id is None:
        self.target_id = 0
      if self.snr is None:
        self.snr = 0.
      if self.range is None:
        self.range = 0.
      if self.speed is None:
        self.speed = 0.
      if self.azimuth is None:
        self.azimuth = 0.
      if self.elevation is None:
        self.elevation = 0.
    else:
      self.target_id = 0
      self.snr = 0.
      self.range = 0.
      self.speed = 0.
      self.azimuth = 0.
      self.elevation = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_H5d().pack(_x.target_id, _x.snr, _x.range, _x.speed, _x.azimuth, _x.elevation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 42
      (_x.target_id, _x.snr, _x.range, _x.speed, _x.azimuth, _x.elevation,) = _get_struct_H5d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_H5d().pack(_x.target_id, _x.snr, _x.range, _x.speed, _x.azimuth, _x.elevation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 42
      (_x.target_id, _x.snr, _x.range, _x.speed, _x.azimuth, _x.elevation,) = _get_struct_H5d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_H5d = None
def _get_struct_H5d():
    global _struct_H5d
    if _struct_H5d is None:
        _struct_H5d = struct.Struct("<H5d")
    return _struct_H5d
