// Auto-generated. Do not edit!

// (in-package ainstein_radar_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class RadarInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.range_min = null;
      this.range_max = null;
      this.speed_min = null;
      this.speed_max = null;
      this.fov_azimuth = null;
      this.fov_elevation = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('range_min')) {
        this.range_min = initObj.range_min
      }
      else {
        this.range_min = 0.0;
      }
      if (initObj.hasOwnProperty('range_max')) {
        this.range_max = initObj.range_max
      }
      else {
        this.range_max = 0.0;
      }
      if (initObj.hasOwnProperty('speed_min')) {
        this.speed_min = initObj.speed_min
      }
      else {
        this.speed_min = 0.0;
      }
      if (initObj.hasOwnProperty('speed_max')) {
        this.speed_max = initObj.speed_max
      }
      else {
        this.speed_max = 0.0;
      }
      if (initObj.hasOwnProperty('fov_azimuth')) {
        this.fov_azimuth = initObj.fov_azimuth
      }
      else {
        this.fov_azimuth = 0.0;
      }
      if (initObj.hasOwnProperty('fov_elevation')) {
        this.fov_elevation = initObj.fov_elevation
      }
      else {
        this.fov_elevation = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RadarInfo
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [range_min]
    bufferOffset = _serializer.float64(obj.range_min, buffer, bufferOffset);
    // Serialize message field [range_max]
    bufferOffset = _serializer.float64(obj.range_max, buffer, bufferOffset);
    // Serialize message field [speed_min]
    bufferOffset = _serializer.float64(obj.speed_min, buffer, bufferOffset);
    // Serialize message field [speed_max]
    bufferOffset = _serializer.float64(obj.speed_max, buffer, bufferOffset);
    // Serialize message field [fov_azimuth]
    bufferOffset = _serializer.float64(obj.fov_azimuth, buffer, bufferOffset);
    // Serialize message field [fov_elevation]
    bufferOffset = _serializer.float64(obj.fov_elevation, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RadarInfo
    let len;
    let data = new RadarInfo(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [range_min]
    data.range_min = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [range_max]
    data.range_max = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [speed_min]
    data.speed_min = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [speed_max]
    data.speed_max = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [fov_azimuth]
    data.fov_azimuth = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [fov_elevation]
    data.fov_elevation = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 48;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ainstein_radar_msgs/RadarInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd15e967e37909c0d954b5177e0bd7244';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message defines metainformation for a radar sensor.
    
    std_msgs/Header header
    
    #######################################################################
    #                    Physical sensing limits                          #
    #######################################################################
    
    # The minimum and maximum range, in meters, of detections (targets)
    # reported by the sensor.
    float64 range_min
    float64 range_max
    
    # The minimum and maximum range, in meters per second, of detections
    # (targets) reported by the sensor.
    float64 speed_min
    float64 speed_max
    
    # The total field of view of the sensor in azimuth and elevation angles
    # reported in degrees and assumed symmetrical.
    float64 fov_azimuth  
    float64 fov_elevation
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RadarInfo(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.range_min !== undefined) {
      resolved.range_min = msg.range_min;
    }
    else {
      resolved.range_min = 0.0
    }

    if (msg.range_max !== undefined) {
      resolved.range_max = msg.range_max;
    }
    else {
      resolved.range_max = 0.0
    }

    if (msg.speed_min !== undefined) {
      resolved.speed_min = msg.speed_min;
    }
    else {
      resolved.speed_min = 0.0
    }

    if (msg.speed_max !== undefined) {
      resolved.speed_max = msg.speed_max;
    }
    else {
      resolved.speed_max = 0.0
    }

    if (msg.fov_azimuth !== undefined) {
      resolved.fov_azimuth = msg.fov_azimuth;
    }
    else {
      resolved.fov_azimuth = 0.0
    }

    if (msg.fov_elevation !== undefined) {
      resolved.fov_elevation = msg.fov_elevation;
    }
    else {
      resolved.fov_elevation = 0.0
    }

    return resolved;
    }
};

module.exports = RadarInfo;
